window.Gleam.initSearch([{"doc":"commonmark","title":"commonmark","content":"# commonmark\n\n[![Package Version](https://img.shields.io/hexpm/v/commonmark)](https://hex.pm/packages/commonmark)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/commonmark/)\n![Erlang-compatible](https://img.shields.io/badge/target-erlang-b83998)\n![JavaScript-compatible](https://img.shields.io/badge/target-javascript-f1e05a)\n\n```sh\ngleam add commonmark\n```\n```gleam\nimport commonmark\nimport gleam/io\n\npub fn main() {\n  &quot;# Hello, Gleam!\n\nThis is a test.&quot;\n  |&gt; commonmark.render_to_html\n  |&gt; io.println\n  // -&gt; &quot;&lt;h1&gt;Hello, Gleam!&lt;/h1&gt;\\n&lt;p&gt;This is a test.&lt;/p&gt;\\n&quot;\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/commonmark&gt;.\n\n[You can view this README as an AST here.][readme-ast]\n\nThere is also an [interactive demo][demo] which you can use to test how this library interacts with your documents.\n\n[readme-ast]: https://github.com/mscharley/gleam-commonmark/tree/main/birdie_snapshots/common_mark_readme.accepted\n[demo]: https://mscharley.github.io/gleam-commonmark/\n\n## Syntax support\n\n🚧 This package is still heavily under construction 🚧\n\n✅ - Completed | 🚧 - In Progress | ❌ - Unsupported\n\n### CommonMark\n\nThe current version of CommonMark targetted is [0.31.2][commonmark].\n\n* ✅ Thematic breaks\n* ✅ ATX headings\n* ✅ Setext headings\n* ✅ Indented code blocks\n* ✅ Fenced code blocks\n* ❌ Link reference definitions\n* ✅ Paragraphs\n* ✅ Block quotes\n* 🚧 Ordered lists\n* 🚧 Unordered lists\n* ❌ Code spans\n* ❌ Emphasis and strong emphasis\n* ❌ Links\n* ❌ Images\n* ✅ Autolinks\n* ✅ Hard line breaks\n* ✅ Soft line breaks\n\nRaw HTML features will be tackled last as the potential security issues around this need to be considered.\n\n* ❌ HTML blocks\n* ❌ Inline HTML\n\n[commonmark]: https://spec.commonmark.org/0.31.2/\n\n### Github Flavoured Markdown\n\nThe current version of GFM targetted is [0.29-gfm][gfm].\n\n* ❌ Tables\n* ❌ Strikethrough\n\n[gfm]: https://github.github.com/gfm/\n\n## Development\n\n```sh\ngleam test              # Run the tests\ngleam run -m benchmark  # Run the benchmarks\ngleam shell             # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"commonmark/ast","title":"BlockNode","content":"pub type BlockNode {\n  HorizontalBreak\n  Heading(level: Int, contents: List(InlineNode))\n  CodeBlock(\n    info: Option(String),\n    full_info: Option(String),\n    contents: String,\n  )\n  HtmlBlock(html: String)\n  Paragraph(contents: List(InlineNode))\n  BlockQuote(contents: List(BlockNode))\n  OrderedList(\n    contents: List(ListItem),\n    start: Int,\n    marker: OrderedListMarker,\n  )\n  UnorderedList(\n    contents: List(ListItem),\n    marker: UnorderedListMarker,\n  )\n}\n Block nodes are used to define the overall structure of a document.\nHorizontalBreak\n\n\nHeading(level: Int, contents: List(InlineNode))\n\n\nCodeBlock(\n  info: Option(String),\n  full_info: Option(String),\n  contents: String,\n)\n\n\nHtmlBlock(html: String)\n\n\nParagraph(contents: List(InlineNode))\n\n\nBlockQuote(contents: List(BlockNode))\n\n\nOrderedList(\n  contents: List(ListItem),\n  start: Int,\n  marker: OrderedListMarker,\n)\n\n\nUnorderedList(\n  contents: List(ListItem),\n  marker: UnorderedListMarker,\n)\n\n\nSynonyms:\ncommonmark/ast.BlockNode\ncommonmark/ast BlockNode","url":"commonmark/ast.html#BlockNode"},{"doc":"commonmark/ast","title":"Document","content":"pub type Document {\n  Document(blocks: List(BlockNode), references: ReferenceList)\n}\n Documents contain all the information necessary to render a document, both structural and\n metadata.\nDocument(blocks: List(BlockNode), references: ReferenceList)\n\n\nSynonyms:\ncommonmark/ast.Document\ncommonmark/ast Document","url":"commonmark/ast.html#Document"},{"doc":"commonmark/ast","title":"EmphasisMarker","content":"pub type EmphasisMarker {\n  AsteriskEmphasisMarker\n  UnderscoreEmphasisMarker\n}\n\nAsteriskEmphasisMarker\n\n\nUnderscoreEmphasisMarker\n\n\nSynonyms:\ncommonmark/ast.EmphasisMarker\ncommonmark/ast EmphasisMarker","url":"commonmark/ast.html#EmphasisMarker"},{"doc":"commonmark/ast","title":"InlineNode","content":"pub type InlineNode {\n  CodeSpan(contents: String)\n  Emphasis(contents: List(InlineNode), marker: EmphasisMarker)\n  StrongEmphasis(\n    contents: List(InlineNode),\n    marker: EmphasisMarker,\n  )\n  StrikeThrough(contents: List(InlineNode))\n  Link(\n    contents: List(InlineNode),\n    title: Option(String),\n    href: String,\n  )\n  ReferenceLink(contents: List(InlineNode), ref: String)\n  Image(alt: String, title: Option(String), href: String)\n  ReferenceImage(alt: String, ref: String)\n  UriAutolink(href: String)\n  EmailAutolink(href: String)\n  HtmlInline(html: String)\n  PlainText(contents: String)\n  HardLineBreak\n  SoftLineBreak\n}\n Inline nodes are used to define the formatting and individual elements that appear in a\n document.\nCodeSpan(contents: String)\n\n\nEmphasis(contents: List(InlineNode), marker: EmphasisMarker)\n\n\nStrongEmphasis(\n  contents: List(InlineNode),\n  marker: EmphasisMarker,\n)\n\n\nStrikeThrough(contents: List(InlineNode))\n\n\nLink(\n  contents: List(InlineNode),\n  title: Option(String),\n  href: String,\n)\n\n\nReferenceLink(contents: List(InlineNode), ref: String)\n\n\nImage(alt: String, title: Option(String), href: String)\n\n\nReferenceImage(alt: String, ref: String)\n\n\nUriAutolink(href: String)\n\n\nEmailAutolink(href: String)\n\n\nHtmlInline(html: String)\n\n\nPlainText(contents: String)\n Literal text content that should be rendered as-is. In particular, this means that the\n content is not HTML-safe, nor is any other precaution taken for specific renderers. Renderers\n should take appropriate precautions to make sure that this text is displayed as presented.\n\n Text content shouldn&#39;t normally contain line breaks. See `HardLineBreak` and `SoftLineBreak`\n for the canonical representation of line breaks that renderers can make decisions about. The\n exception is `CodeBlock(Text(&quot;&quot;))` which may contain line breaks (standardised to `&quot;\\n&quot;`) as\n the full block of text inside the `CodeBlock` is returned as a single pre-formatted text blob.\n\nHardLineBreak\n\n\nSoftLineBreak\n\n\nSynonyms:\ncommonmark/ast.InlineNode\ncommonmark/ast InlineNode","url":"commonmark/ast.html#InlineNode"},{"doc":"commonmark/ast","title":"ListItem","content":"pub type ListItem {\n  ListItem(contents: List(BlockNode))\n  TightListItem(contents: List(BlockNode))\n}\n\nListItem(contents: List(BlockNode))\n\n\nTightListItem(contents: List(BlockNode))\n\n\nSynonyms:\ncommonmark/ast.ListItem\ncommonmark/ast ListItem","url":"commonmark/ast.html#ListItem"},{"doc":"commonmark/ast","title":"OrderedListMarker","content":"pub type OrderedListMarker {\n  PeriodListMarker\n  BracketListMarker\n}\n\nPeriodListMarker\n The list used a `.` as the marker for the ordered list\n\nBracketListMarker\n The list used a `)` as the marker for the ordered list\n\nSynonyms:\ncommonmark/ast.OrderedListMarker\ncommonmark/ast OrderedListMarker","url":"commonmark/ast.html#OrderedListMarker"},{"doc":"commonmark/ast","title":"Reference","content":"pub type Reference {\n  Reference(href: String, title: Option(String))\n}\n A reference used with ReferenceLink nodes\nReference(href: String, title: Option(String))\n\n\nSynonyms:\ncommonmark/ast.Reference\ncommonmark/ast Reference","url":"commonmark/ast.html#Reference"},{"doc":"commonmark/ast","title":"ReferenceList","content":"pub type ReferenceList =\n  Dict(String, Reference)\n A dictionary of references keyed by the name of the reference\n\nSynonyms:\ncommonmark/ast.ReferenceList\ncommonmark/ast ReferenceList","url":"commonmark/ast.html#ReferenceList"},{"doc":"commonmark/ast","title":"UnorderedListMarker","content":"pub type UnorderedListMarker {\n  DashListMarker\n  PlusListMarker\n  AsteriskListMarker\n}\n\nDashListMarker\n The list used a `-` as the marker for the unordered list\n\nPlusListMarker\n The list used a `+` as the marker for the unordered list\n\nAsteriskListMarker\n The list used a `*` as the marker for the unordered list\n\nSynonyms:\ncommonmark/ast.UnorderedListMarker\ncommonmark/ast UnorderedListMarker","url":"commonmark/ast.html#UnorderedListMarker"},{"doc":"commonmark/ast","title":"commonmark/ast","content":" This module defines the Markdown AST used.\n\n This AST can be used to manipulate markdown documents or render them with your own\n algorithm.\n\n CommonMark defines two major types of elements which have a hierarchical relationship:\n\n * A Document has many blocks.\n * A block has zero or more inline elements that make up it&#39;s content.\n * Inline elements define the textual contents of the document.","url":"commonmark/ast.html"},{"doc":"commonmark","title":"parse","content":"pub fn parse(document: String) -&gt; Document\n Parse a CommonMark document into an AST.\nSynonyms:\ncommonmark.parse\ncommonmark parse","url":"commonmark.html#parse"},{"doc":"commonmark","title":"render_to_html","content":"pub fn render_to_html(document: String) -&gt; String\n Render a CommonMark document into a HTML string.\n\n This version follows the advice in the CommonMark spec to silently resolve errors.\nSynonyms:\ncommonmark.render_to_html\ncommonmark render_to_html","url":"commonmark.html#render_to_html"},{"doc":"commonmark","title":"render_to_html_strict","content":"pub fn render_to_html_strict(\n  document: String,\n) -&gt; Result(String, Nil)\n Render a CommonMark document into a HTML string.\n \n This uses a more strict rendered that won&#39;t attempt to fix issues in the document.\nSynonyms:\ncommonmark.render_to_html_strict\ncommonmark render_to_html_strict","url":"commonmark.html#render_to_html_strict"},{"doc":"commonmark","title":"to_html","content":"pub fn to_html(document: Document) -&gt; String\n Render an AST into a HTML string.\n\n This version follows the advice in the CommonMark spec to silently resolve errors.\nSynonyms:\ncommonmark.to_html\ncommonmark to_html","url":"commonmark.html#to_html"},{"doc":"commonmark","title":"to_html_strict","content":"pub fn to_html_strict(document: Document) -&gt; Result(String, Nil)\n Render an AST into a HTML string.\n \n This uses a more strict rendered that won&#39;t attempt to fix issues in the document.\nSynonyms:\ncommonmark.to_html_strict\ncommonmark to_html_strict","url":"commonmark.html#to_html_strict"},{"doc":"commonmark","title":"commonmark","content":" CommonMark implementation for Gleam!\n\n This package provides a simple interface to parse CommonMark and common extensions\n into either an AST for further manipulation or directly to HTML.","url":"commonmark.html"}]);